package com.wincornixdorf.vnc.gui;

import java.awt.Component;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

import com.wincornixdorf.vnc.rfb.ft.FTFile;

public class FSTableCellRenderer extends DefaultTableCellRenderer {

    private static final long serialVersionUID = 1L;

    private final ImageIcon iconFolderV = new ImageIcon( this.getClass().getResource( "/32x32/filesystems/folder.png"));
    private final ImageIcon iconFolderH = new ImageIcon( this.getClass().getResource( "/32x32/filesystems/folder_grey.png"));
    //private final ImageIcon iconFolderZ = new ImageIcon( this.getClass().getResource( "/32x32/filesystems/folder_tar.png"));
    private final ImageIcon iconFldrUp  = new ImageIcon( this.getClass().getResource( "/32x32/actions/go-up-dir.png"));
    private final ImageIcon iconParentH = new ImageIcon( this.getClass().getResource( "/32x32/filesystems/folder_grey_open.png"));
    private final ImageIcon iconPlaceH  = new ImageIcon( this.getClass().getResource( "/32x32/filesystems/network.png"));
    private final ImageIcon iconFileV   = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/document.png"));
    private final ImageIcon iconFileH   = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/document_hidden.png"));

    private final ImageIcon imtHTML     = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/html.png"));
    private final ImageIcon imtISO      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/cdimage.png"));
    private final ImageIcon imtDVI      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/dvi.png"));
    private final ImageIcon imtEXE      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/exec_wine.png"));
    private final ImageIcon imtTMP      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/file_temporary.png"));
    private final ImageIcon imtTTF      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/font_truetype.png"));
    private final ImageIcon imtKPRESENT = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/kpresenter_kpr.png"));
    private final ImageIcon imtKSPREAD  = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/kspread_ksp.png"));
    private final ImageIcon imtKWORD    = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/kword_kwd.png"));
    private final ImageIcon imtLOG      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/log.png"));
    private final ImageIcon imtMAKE     = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/make.png"));
    //private final ImageIcon imtMIDI     = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/midi.png"));
    private final ImageIcon imtPDF      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/pdf.png"));
    private final ImageIcon imtPS       = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/postscript.png"));
    private final ImageIcon imtQKT      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/quicktime.png"));
    private final ImageIcon imtREADME   = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/readme.png"));
    private final ImageIcon imtSCRIPT   = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/shellscript.png"));
    private final ImageIcon imtTXT      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/txt.png"));
    private final ImageIcon imtTAR      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/tar.png"));
    private final ImageIcon imtJAR      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/tar.png"));
    private final ImageIcon imtTGZ      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/tgz.png"));
    private final ImageIcon imtZIP      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/tar.png"));
    private final ImageIcon imtCPP      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_cpp.png"));
    private final ImageIcon imtC        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_c.png"));
    private final ImageIcon imtJAVA     = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_java.png"));
    private final ImageIcon imtF        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_f.png"));
    private final ImageIcon imtH        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_h.png"));
    private final ImageIcon imtL        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_l.png"));
    private final ImageIcon imtJ        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_j.png"));
    private final ImageIcon imtO        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_o.png"));
    private final ImageIcon imtP        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_p.png"));
    private final ImageIcon imtPY       = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_py.png"));
    private final ImageIcon imtS        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_s.png"));
    private final ImageIcon imtY        = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/source_y.png"));
    private final ImageIcon imtDEB      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/deb.png"));
    private final ImageIcon imtRPM      = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/rpm.png"));
    private final ImageIcon imtIMAGE    = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/image.png"));
    //private final ImageIcon imtSOUND    = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/sound.png"));
    //private final ImageIcon imtVIDEO    = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/video.png"));
    //private final ImageIcon imtUNKNOWN  = new ImageIcon( this.getClass().getResource( "/32x32/mimetypes/image.png"));

    public FSTableCellRenderer() {
    }

    public Component getTableCellRendererComponent( JTable table,
                                                    Object value,
                                                    boolean isSelected,
                                                    boolean hasFocus,
                                                    int row, int column)
    {
        if ( !( value instanceof FTFile)) {
            setText( (String)value);
            return( this);
        }

        FTFile f = (FTFile)value;
        setText( f.getFilename());

        setIcon( getIcon( f));
        setToolTipText( getTTT( f));

        if ( isSelected) {
            setBackground( table.getSelectionBackground());
            setForeground( table.getSelectionForeground());
        } else {
            setBackground( table.getBackground());
            setForeground( table.getForeground());
        }

        setEnabled( table.isEnabled());
        setFont( table.getFont());
        setOpaque( true);
        return this;
    }

    private ImageIcon getIcon( FTFile f) {
        if ( f == null) return null;

        if ( f.servesAsPlaceholder()) return ( iconPlaceH);

        boolean isFolder = f.isDirectory();
        boolean isHidden = f.isHidden();
        boolean isParent = f.isParent();
//         boolean isZipped = f.isCompressed();
//         boolean isSystem = f.isSystem();

        if ( isParent) return( isHidden ? iconParentH : iconFldrUp);

//         if ( isZipped) return( iconFolderZ);

        if ( isFolder) {
            return( isHidden ? iconFolderH : iconFolderV);
        } else {
            return guessFiletype( f.getFilename(), isHidden);
//             return( isHidden ? iconFileH : iconFileV);
        }
    }

    private ImageIcon guessFiletype( String fn, boolean hidden) {
        ImageIcon fallback = hidden ? iconFileH : iconFileV;
        if ( fn == null) return fallback;

        fn = fn.toLowerCase();
        if ( fn.endsWith( ".htm") || fn.endsWith( ".html")) return imtHTML;
        if ( fn.endsWith( ".iso")) return imtISO;
        if ( fn.endsWith( ".dvi")) return imtDVI;
        if ( fn.endsWith( ".exe")) return imtEXE;
        if ( fn.endsWith( ".tmp")) return imtTMP;
        if ( fn.endsWith( ".ttf")) return imtTTF;
        if ( fn.endsWith( ".ppt")) return imtKPRESENT;
        if ( fn.endsWith( ".xls")) return imtKSPREAD;
        if ( fn.endsWith( ".doc")) return imtKWORD;
        if ( fn.endsWith( ".log")) return imtLOG;
        if ( fn.equals( "makefile")) return imtMAKE;
        if ( fn.endsWith( ".pdf")) return imtPDF;
        if ( fn.endsWith( ".ps")) return imtPS;
        if ( fn.endsWith( ".qt")) return imtQKT;
        if ( fn.equals( "readme")) return imtREADME;
        if ( fn.endsWith( ".sh") || fn.endsWith( ".bat")) return imtSCRIPT;
        if ( fn.endsWith( ".txt")) return imtTXT;
        if ( fn.endsWith( ".tar")) return imtTAR;
        if ( fn.endsWith( ".tgz") || fn.endsWith( ".tar.gz")) return imtTGZ;
        if ( fn.endsWith( ".jar")) return imtJAR;
        if ( fn.endsWith( ".zip")) return imtZIP;
        if ( fn.endsWith( ".cpp")) return imtCPP;
        if ( fn.endsWith( ".c")) return imtC;
        if ( fn.endsWith( ".java")) return imtJAVA;
        if ( fn.endsWith( ".f")) return imtF;
        if ( fn.endsWith( ".h")) return imtH;
        if ( fn.endsWith( ".l")) return imtL;
        if ( fn.endsWith( ".j")) return imtJ;
        if ( fn.endsWith( ".o")) return imtO;
        if ( fn.endsWith( ".p")) return imtP;
        if ( fn.endsWith( ".py")) return imtPY;
        if ( fn.endsWith( ".s")) return imtS;
        if ( fn.endsWith( ".y")) return imtY;
        if ( fn.endsWith( ".deb")) return imtDEB;
        if ( fn.endsWith( ".rpm")) return imtRPM;

        if ( fn.endsWith( ".gif") || fn.endsWith( ".tiff") ||
             fn.endsWith( ".png") || fn.endsWith( ".bmp")) return imtIMAGE;

        return fallback;
    }

    private String getFileType( FTFile f) {
    	return f.isDirectory() ? "Directory" : "File";
    }

    private String getFileAttributes( FTFile f) {
    	String rs = "[";
    	Vector<String> attribs = new Vector<String>();
    	
    	if ( f.test( FTFile.MS_READONLY)) attribs.add( "Read-Only"); 
    	if ( f.isHidden()) attribs.add( "Hidden");
    	if ( f.test( FTFile.MS_SYSTEM))   attribs.add( "System");
    	if ( f.test( FTFile.MS_ARCHIVE))  attribs.add( "Archive");
    	if ( f.test( FTFile.MS_TEMPORARY)) attribs.add( "Temporary");
    	
    	if ( attribs.isEmpty()) return "[NONE]";

    	Iterator<String> itAttribs = attribs.iterator();
    	while ( itAttribs.hasNext()) {
    		rs += itAttribs.next();
    		if ( itAttribs.hasNext()) rs+=",";
    	}
    	return rs + "]";
    }
    
    private String getTTT( FTFile f) {
        if ( f == null) return "Error";
        StringBuilder sb = new StringBuilder( 1024);

        if ( f.servesAsPlaceholder()) {
            sb.append( "<html>");
            sb.append( "<b>The contents of this directory have <i>not</i> been loaded yet.</b><br><br>");
            sb.append( "Please force a <i>reload</i> by:");
            sb.append( "<ul type=\"circle\">");
            sb.append( "<li>Pressing 'reload'</li>");
            sb.append( "<li>Double clicking this item</li>");
            sb.append( "<li>Selecting a different location</li>");
            sb.append( "</ul>");
            sb.append( "</html>");
            return sb.toString();
        }

        sb.append( "<html>");

        sb.append( "<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" rules=\"groups\">");

        sb.append( "<tr><th align=\"left\">Type:</th><td><b>" + getFileType( f) +"</b></td></tr>");

        
        sb.append( "<tr><th align=\"left\">Name</th><td><b>" + f.getFilename() +"</b></td></tr>");
        sb.append( "<tr><th align=\"left\">Size (B)</th><td><b>" + f.getSizeAsString() +"</b></td></tr>");
        sb.append( "<tr><th align=\"left\">Attributes</th><td><b>" + getFileAttributes( f) +"</b></td></tr>");
//        sb.append( "<tr><th align=\"left\">Read only</th><td>" + f.test( FTFile.MS_READONLY) +"</td></tr>");
//        sb.append( "<tr><th align=\"left\">Hidden</th><td>" + f.isHidden() +"</td></tr>");
//        sb.append( "<tr><th align=\"left\">System</th><td>" + f.test( FTFile.MS_SYSTEM) +"</td></tr>");
//        sb.append( "<tr><th align=\"left\">Archive</th><td>" + f.test( FTFile.MS_ARCHIVE) +"</td></tr>");
//        sb.append( "<tr><th align=\"left\">Temporary</th><td>" + f.test( FTFile.MS_TEMPORARY) +"</td></tr>");
//         sb.append( "<tr><th align=\"left\">Compressed</th><td>" + f.test( FTFile.MS_COMPRESSED) +"</td></tr>");
//         sb.append( "<tr><th align=\"left\">Offline</th><td>" + f.test( FTFile.MS_OFFLINE) +"</td></tr>");
//         sb.append( "<tr><th align=\"left\">Encrypted</th><td>" + f.test( FTFile.MS_ENCRYPTED) +"</td></tr>");
//        sb.append( "<tr><th align=\"left\">System</th><td>" + f.test( FTFile.MS_SYSTEM) +"</td></tr>");

        sb.append( "<tr><th align=\"left\">Last write</th><td>" + f.getLastWrittenToOn() +"</td></tr>");
        sb.append( "<tr><th align=\"left\">Last Access</th><td>" + f.getLastAccessedOn() +"</td></tr>");
        sb.append( "<tr><th align=\"left\">Created on</th><td>" + f.getCreatedOn() +"</td></tr>");

        sb.append( "</table>");

        sb.append( "</html>");

        return sb.toString();
    }

}
