package com.wincornixdorf.vnc.gui;

import java.awt.FlowLayout;

import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

import com.wincornixdorf.vnc.global.VNCAction;
import com.wincornixdorf.vnc.global.VNCViewer;

/**
 * Copyright (C) 2001,2002 HorizonLive.com, Inc.  All Rights Reserved.
 * Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 * <p>
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */

public class JButtonPanel extends JPanel {
    private static final long serialVersionUID = -5468581181154678574L;
    private JToggleButton tbFB = null;
    private JToggleButton tbFT = null;
    private JToggleButton tbLG = null;

    public JButtonPanel(VNCViewer v) {
        setLayout(new FlowLayout(FlowLayout.LEFT, 3, 3));

        JComboBox keyboardLayout = new JComboBox();
        keyboardLayout.setAction(v.actions.getActionByGoal(VNCAction.Goal.CHANGE_KEYBOARD_LAYOUT));
        keyboardLayout.setModel(new DefaultComboBoxModel(new String[]{"US", "DE", "FR", "ES"}));
        add(keyboardLayout);

        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.QUIT)));

        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.TOGGLE_GP_UI_ENABLED)));

        if (VNCViewer.isDivine())
            add(buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.LIST_SESSIONS), false));

        tbFB = buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.SHOW_FB), true);
        tbFT = buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.SHOW_FT), true);
        tbLG = buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.SHOW_LG), true);

        ButtonGroup bg = new ButtonGroup();
        bg.add(tbFB);
        add(tbFB);
        bg.add(tbFT);
        add(tbFT);
        bg.add(tbLG);
        add(tbLG);

        add(buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.OPTIONS), false));
        add(buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.CLIPBOARD), false));

        if (v.rec != null) add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.RECORD)));

        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.CTRLALTDEL)));
        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.META)));
        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.REFRESH)));
        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.DISABLE_CONTROLS)));

        add(buildToggleButton(v.actions.getActionByGoal(VNCAction.Goal.TOGGLE_FULLSCREEN), false));
        //add( buildToggleButton( v.actions.toggleMenu, false));

        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.CONTROL_NAVIGATOR)));

        add(buildButton(v.actions.getActionByGoal(VNCAction.Goal.ABOUT)));
    }

    private JButton buildButton(Action a) {
        JButton b = new JButton(a);
        b.setFocusable(false);
        return b;
    }

    private JToggleButton buildToggleButton(Action a, boolean scratchText) {
        JToggleButton b = new JToggleButton(a);
        b.setFocusable(false);
        if (scratchText) b.setText("");
        return b;
    }
}
