package com.wincornixdorf.vnc.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import com.wincornixdorf.vnc.global.VNCViewer;

public class MSLogo extends JPanel implements java.awt.image.ImageObserver {

    private static final    long        serialVersionUID    = 4670990992325736294L;

    private static final    int         lm                  = 20; // Logo Margin

    private                 ImageIcon   iWLogo              = new ImageIcon( this.getClass().getResource( "/logo_dn.gif"));
    private                 ImageIcon   iGlobe              = new ImageIcon( this.getClass().getResource( "/loginmainback.jpg"));
    private                 ImageIcon   iSplit              = new ImageIcon( this.getClass().getResource( "/toplineright.jpg"));

    public MSLogo() {
        super();
    }

    public Dimension getPreferredSize() {
        int minW = iGlobe.getIconWidth();
        int minH = iGlobe.getIconHeight() +
                iWLogo.getIconHeight() +
                iSplit.getIconHeight() + 2 * lm;
        return( new Dimension( minW, minH));
    }

    public void paint( Graphics g) {
        Rectangle r = g.getClipBounds();

        //int lw = iWLogo.getIconWidth();
        //int gw = iGlobe.getIconWidth();
        int sw = iSplit.getIconWidth();

        int lh = iWLogo.getIconHeight();
        int gh = iGlobe.getIconHeight();
        int sh = iSplit.getIconHeight();

        int lm2 = 2 * lm;
        String ms = "eServices Platform";

        Color colGlobeBackground = new Color( 183, 217, 242);
        Color colSplitBackground = new Color( 191,   0,  46);

        g.setColor( Color.white);
        g.fillRect( 0, 0, (int)r.getWidth(), (int)r.getHeight());

        g.setColor( colSplitBackground);
        g.fillRect( 0, lh + lm2, (int)r.getWidth(), sh);

        g.setColor( colGlobeBackground);
        g.fillRect( 0, lh + sh + lm2, (int)r.getWidth(), gh);

        g.drawImage( iWLogo.getImage(), lm, lm, Color.white, this);
/*        g.drawImage( iSplit.getImage(), (int)r.getWidth() - sw, lh + lm2, colSplitBackground, this);*/
        g.drawImage( iGlobe.getImage(), 0, lh + sh + lm2, colGlobeBackground, this);

        int imgs2fit = (int)( r.width / sw) + 1;
        for ( int i = 1; i <= imgs2fit; i++) {
            g.drawImage( iSplit.getImage(), r.width - i * sw, lh + lm2, colSplitBackground, this);
        }

        g.setColor( Color.white);
        int txtWidth = g.getFontMetrics().stringWidth( ms);
        g.drawString( ms, (int)( r.getWidth() - txtWidth - lm), (int)( lh + lm2 + sh / 2));

        String vs = VNCViewer.appBaseline( true);
        g.setColor( Color.black);
        int verWidth = g.getFontMetrics().stringWidth( vs);
        g.drawString( vs, (int)( r.getWidth() - verWidth - lm), (int)( lh + lm + sh + gh));
    }

    public boolean imageUpdate( Image img, int infoflags, int x, int y, int width, int height)
    {
        // We won't do anything here as we do not
        // expect the images to change at any time
        return true;
    }
}
