package com.wincornixdorf.vnc.gui.ft;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;


public class FTCmdButtons extends JPanel {
    private static final long serialVersionUID = -3552521205923146808L;
    private final Icon clientIcon = new ImageIcon( this.getClass().getResource( "/16x16/gohome.png"));
    private final Icon serverIcon = new ImageIcon( this.getClass().getResource( "/16x16/server.png"));

    public JButton      btnDelete               = null;
    public JButton      btnNewFolder            = null;
    public JButton      btnRoot                 = null;
    public JButton      btnReload               = null;
    public JButton      btnTransfer             = null;

    public FTBookmarker bookmark                = null;

    private JLabel      lHostname               = null;

    public FTCmdButtons( boolean serverButtons, String location) {
        super();

        Insets              dins = new Insets( 2, 2, 2, 2);
        GridBagLayout       gb   = new GridBagLayout();
        GridBagConstraints  c    = new GridBagConstraints();

        setLayout( gb);

        Icon icon = serverButtons ? serverIcon : clientIcon;
        lHostname = new JLabel( location, icon, SwingConstants.CENTER);

        btnReload = new JButton( "Reload", new ImageIcon( this.getClass().getResource( "/16x16/reload.png")));
        btnRoot = new JButton( "Root", new ImageIcon( this.getClass().getResource( "/16x16/2uparrow.png")));

        btnDelete = new JButton( "Delete", new ImageIcon( this.getClass().getResource( "/16x16/remove.png")));
        btnDelete.setEnabled( false);

        btnNewFolder = new JButton( "New Folder", new ImageIcon( this.getClass().getResource( "/16x16/folder_new.png")));

        String s = serverButtons ? "/16x16/previous.png" : "/16x16/next.png";
        btnTransfer = new JButton( "Transfer", new ImageIcon( this.getClass().getResource( s)));

        bookmark = new FTBookmarker( serverButtons);

        c = new GridBagConstraints( 0, 0, GridBagConstraints.REMAINDER, 1, 1.0, 1.0,
        GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
        gb.setConstraints( lHostname, c);
        add( lHostname);

        if ( serverButtons) {
            // on the servers side the transfer Btn is left and stretches 2 cols
            c = new GridBagConstraints( 0, 1, 2, 1, 1.0, 1.0,
            GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
            gb.setConstraints( btnTransfer, c);
            add( btnTransfer);

            c = new GridBagConstraints( 2, 1, 1, 1, 1.0, 1.0,
            GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
            gb.setConstraints( btnReload, c);
            add( btnReload);
        } else {
            c = new GridBagConstraints( 0, 1, 1, 1, 1.0, 1.0,
            GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
            gb.setConstraints( btnReload, c);
            add( btnReload);

            // on the client side the transfer Btn is right and stretches 2 cols
            c = new GridBagConstraints( 1, 1, 2, 1, 1.0, 1.0,
            GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
            gb.setConstraints( btnTransfer, c);
            add( btnTransfer);
        }

        c = new GridBagConstraints( 0, 2, 1, 1, 1.0, 1.0,
        GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
        gb.setConstraints( btnDelete, c);
        add( btnDelete);

        c = new GridBagConstraints( 1, 2, 1, 1, 1.0, 1.0,
        GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
        gb.setConstraints( btnNewFolder, c);
        add( btnNewFolder);

        c = new GridBagConstraints( 2, 2, 1, 1, 1.0, 1.0,
        GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
        gb.setConstraints( btnRoot, c);
        add( btnRoot);


        c = new GridBagConstraints( 0, 3, 3, 1, 1.0, 1.0,
        GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, dins, 0, 0);
        gb.setConstraints( bookmark, c);
        add( bookmark);
    }

    public void setLocation( String s) {
        lHostname.setText( s);
    }

    public void addListener( ActionListener l) {
        btnDelete.addActionListener( l);
        btnNewFolder.addActionListener( l);
        btnRoot.addActionListener( l);
        btnReload.addActionListener( l);
        btnTransfer.addActionListener( l);
        bookmark.addActionListener( l);
    }

    public void setFTBtnsEnabled( boolean b) {
        btnDelete.setEnabled( b);
        btnNewFolder.setEnabled( b);
        btnRoot.setEnabled( b);
        btnReload.setEnabled( b);
        btnTransfer.setEnabled( b);
        bookmark.setEnabled( b);
    }
}
