package com.wincornixdorf.vnc.rfb.debug;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ToolBox {

	// Thanks to http://stackoverflow.com/questions/46146/what-are-the-java-regular-expressions-for-matching-ipv4-and-ipv6-strings
    private static final String 	O255 				= "(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)";
    public  static final String		IPV4_REGEX 			= "\\A" + O255 + "(\\." + O255 + "){3}\\z";
    private static final Pattern 	IPV4_REGEX_PATTERN	= Pattern.compile( IPV4_REGEX);
    
    public static String boolYN( boolean b, String yes, String no) {
    	if ( yes == null) yes = "Y";
    	if ( no  == null) no  = "N";
    	return b ? yes : no;
    }

    // TODO: Implement an IPv6 equivalent 
    public static boolean looksLikeIP4Address( String s) {
    	Matcher m = IPV4_REGEX_PATTERN.matcher( s);
		return m.matches();
    }
    
	public static String escapeCRLF( String s) {
		if ( s == null) return "" + null;
		return s.replaceAll( "\n", "<CRLF>");
	}
	
    private static String prePadZeros( int i) {
    	if ( i <=  9) return "00" + i;
    	if ( i <= 99) return  "0" + i;
    	return "" + i;
    }
    
    public  static String armourBytes( byte[] b, String sep, boolean prePad)
    {
        String rval = "";
        int    i    = 0;
        int    h    = 0;
        String pp   = "";

        if ( b == null || b.length <= 0) return( "THAT was a FAIL son!");
        
        if ( sep == null || sep.isEmpty()) sep = "-";

        while ( i < b.length) {
            h = b[ i] < 0 ? 256 + b[ i] : b[ i];
            pp = prePad ? prePadZeros( h) : "" + i;
            rval = rval + pp + sep;
            i++;
        }

        return rval.length() <= 0 ? rval : rval.substring( 0, rval.length() - 1);
    }
}
